## kwstyle 1.0.0+cvs20090716

=== Testing/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${KWStyle_SOURCE_DIR})

SET(KWSTYLE_TESTS  ${CXX_TEST_PATH}/KWStyleTests)

SET(
 KWStyleTests_SRCS
 kwsSemiColonSpaceTest.cxx
 kwsStatementPerLineTest.cxx
 kwsVariablePerLineTest.cxx
 kwsSwitchCaseTest.cxx
 kwsBadCharactersTest.cxx
)

FOREACH(TestFiles ${KWStyleTests_SRCS})   
  GET_FILENAME_COMPONENT(TestProgram ${TestFiles} NAME_WE)   
  ADD_TEST(${TestProgram} ${KWSTYLE_TESTS} ${TestProgram}) 
ENDFOREACH(TestFiles)

SET(KWStyleTests_SRCS
 ${KWStyleTests_SRCS}
 kwsRunKWStyleTest.cxx
 )

ADD_EXECUTABLE( KWStyleTests KWStyleTests.cxx ${KWStyleTests_SRCS})
TARGET_LINK_LIBRARIES(KWStyleTests KWStyleLib kwssys)


MACRO(ADD_TEST_FROM_BUG_TRACKER BUG_NUMBER FILENAME)
  ADD_TEST(Test${BUG_NUMBER} ${KWSTYLE_TESTS}
  --compare ${KWStyle_SOURCE_DIR}/Testing/Data/${BUG_NUMBER}-output.xml
            ${KWStyle_BINARY_DIR}/${BUG_NUMBER}-output.xml
  kwsRunKWStyleTest ${KWStyle_BINARY_DIR}/KWStyle -xml ${KWStyle_SOURCE_DIR}/Testing/Data/${BUG_NUMBER}-KWStyleConfiguration.kws.xml
  -exportxml ${KWStyle_BINARY_DIR}/${BUG_NUMBER}-output.xml
  ${KWStyle_SOURCE_DIR}/Testing/Data/${BUG_NUMBER}-${FILENAME})

ENDMACRO(ADD_TEST_FROM_BUG_TRACKER BUG_NUMBER FILENAME)

ADD_TEST_FROM_BUG_TRACKER(0001 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4204 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4227 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4259 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4260 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4262 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4296 test.h)
ADD_TEST_FROM_BUG_TRACKER(4297 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4301 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4302 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4303 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4316 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4317 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4318 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4319 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4327 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4344 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4345 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(4518 test.h)
ADD_TEST_FROM_BUG_TRACKER(4531 test.h)
ADD_TEST_FROM_BUG_TRACKER(4549 test.h)
ADD_TEST_FROM_BUG_TRACKER(5031 test.cpp)
ADD_TEST_FROM_BUG_TRACKER(5032 test.h)
ADD_TEST_FROM_BUG_TRACKER(5059 test.h)
ADD_TEST_FROM_BUG_TRACKER(5086 test.h)

=== Utilities/KWSys/CMakeLists.txt ===
#=============================================================================
#
#  Program:   KWSys - Kitware System Library
#  Module:    $RCSfile: CMakeLists.txt,v $
#
#  Copyright (c) Kitware, Inc., Insight Consortium.  All rights reserved.
#  See Copyright.txt or http://www.kitware.com/Copyright.htm for details.
#
#     This software is distributed WITHOUT ANY WARRANTY; without even
#     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
#     PURPOSE.  See the above copyright notices for more information.
#
#=============================================================================

# The Kitware System Library is intended to be included in other
# projects.  It is completely configurable in that the library's
# namespace can be configured and the components that are included can
# be selected invididually.

# Typical usage is to import the kwsys directory tree into a
# subdirectory under a parent project and enable the classes that will
# be used.  All classes are disabled by default.  The CMake listfile
# above this one configures the library as follows:
#
#  SET(KWSYS_NAMESPACE foosys)
#  SET(KWSYS_USE_Directory 1)    # Enable Directory class.
#  SUBDIRS(kwsys)
#
# Optional settings are as follows:
#
#  KWSYS_HEADER_ROOT = The directory into which to generate the kwsys headers.
#                      A directory called "${KWSYS_NAMESPACE}" will be
#                      created under this root directory to hold the files.
#
#    Example:
#
#      SET(KWSYS_HEADER_ROOT ${PROJECT_BINARY_DIR})
#      INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
#
#  KWSYS_IOS_FORCE_OLD = Force use of old non-ANSI C++ streams even if
#                        new streams are available.  This may be used
#                        by projects that cannot configure their
#                        streams library.
#    Example:
#
#      SET(KWSYS_IOS_FORCE_OLD 1)
#
#
# Optional settings to setup install rules work in one of two ways.
# The modern way utilizes the CMake 2.4 INSTALL command.  Settings
# for this mode are as follows:
#
#  KWSYS_INSTALL_BIN_DIR     = The installation target directories into
#  KWSYS_INSTALL_LIB_DIR       which the libraries and headers from
#  KWSYS_INSTALL_INCLUDE_DIR   kwsys should be installed by a "make install".
#                              The values should be specified relative to
#                              the installation prefix and NOT start with '/'.
#
#  KWSYS_INSTALL_COMPONENT_NAME_RUNTIME     = Name of runtime and development
#  KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT   installation components.
#                                             If not given the install rules
#                                             will not be in any component.
#
#    Example:
#
#      SET(KWSYS_INSTALL_BIN_DIR bin)
#      SET(KWSYS_INSTALL_LIB_DIR lib)
#      SET(KWSYS_INSTALL_INCLUDE_DIR include)
#      SET(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME Runtime)
#      SET(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT Development)
#
# The old way uses the original CMake INSTALL_* commands.  Settings
# for this mode are as follows:
#
#  KWSYS_LIBRARY_INSTALL_DIR = The installation target directories into
#  KWSYS_HEADER_INSTALL_DIR    which the libraries and headers from
#                              kwsys should be installed by a "make install".
#                              The values should be specified relative to
#                              the installation prefix and start with a '/'.
#    Example:
#
#      SET(KWSYS_LIBRARY_INSTALL_DIR /lib)
#      SET(KWSYS_HEADER_INSTALL_DIR /include)
#
# The modern way will be used whenever the INSTALL command is
# available.  If the settings are not available the old names will be
# used to construct them.  The old way will be used whenever the
# INSTALL command is not available.  If the settings are not available
# the new names will be used to construct them.

# Once configured, kwsys should be used as follows from C or C++ code:
#
#  #include <foosys/Directory.hxx>
#   ...
#  foosys::Directory directory;
#

# NOTE: This library is intended for internal use by Kitware-driven
# projects.  In order to keep it simple no attempt will be made to
# maintain backward compatibility when changes are made to KWSys.
# When an incompatible change is made Kitware's projects that use
# KWSys will be fixed, but no notification will necessarily be sent to
# any outside mailing list and no documentation of the change will be
# written.

#-----------------------------------------------------------------------------
# If a namespace is not specified, use "kwsys" and enable testing.
# This should be the case only when kwsys is not included inside
# another project and is being tested.
IF(NOT KWSYS_NAMESPACE)
  SET(KWSYS_NAMESPACE "kwsys")
  SET(KWSYS_STANDALONE 1)
ENDIF(NOT KWSYS_NAMESPACE)
IF(KWSYS_STANDALONE)
  CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
  IF(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0003 NEW)
  ENDIF(COMMAND CMAKE_POLICY)
ENDIF(KWSYS_STANDALONE)

#-----------------------------------------------------------------------------
# The project name is that of the specified namespace.
PROJECT(${KWSYS_NAMESPACE})

# Some properties we set only with CMake 2.6 and above.
IF(COMMAND SET_PROPERTY)
  MACRO(KWSYS_SET_PROPERTY)
    SET_PROPERTY(${ARGV})
  ENDMACRO(KWSYS_SET_PROPERTY)
ELSE(COMMAND SET_PROPERTY)
  MACRO(KWSYS_SET_PROPERTY)
  ENDMACRO(KWSYS_SET_PROPERTY)
ENDIF(COMMAND SET_PROPERTY)

# Tell CMake how to follow dependencies of sources in this directory.
IF(COMMAND SET_PROPERTY)
  SET_PROPERTY(DIRECTORY
    PROPERTY IMPLICIT_DEPENDS_INCLUDE_TRANSFORM
    "KWSYS_HEADER(%)=<${KWSYS_NAMESPACE}/%>"
    )
ENDIF(COMMAND SET_PROPERTY)

# Select library components.
IF(KWSYS_STANDALONE OR CMake_SOURCE_DIR)
  SET(KWSYS_ENABLE_C 1)

  # Enable all components.
  SET(KWSYS_USE_Base64 1)
  SET(KWSYS_USE_Directory 1)
  SET(KWSYS_USE_DynamicLoader 1)
  SET(KWSYS_USE_Glob 1)
  SET(KWSYS_USE_MD5 1)
  SET(KWSYS_USE_Process 1)
  SET(KWSYS_USE_RegularExpression 1)
  SET(KWSYS_USE_Registry 1)
  SET(KWSYS_USE_System 1)
  SET(KWSYS_USE_SystemTools 1)
  SET(KWSYS_USE_CommandLineArguments 1)
  SET(KWSYS_USE_FundamentalType 1)
  SET(KWSYS_USE_Terminal 1)
  SET(KWSYS_USE_IOStream 1)
  SET(KWSYS_USE_DateStamp 1)
  SET(KWSYS_USE_String 1)
  SET(KWSYS_USE_SystemInformation 1)
  SET(KWSYS_USE_CPU 1)
ENDIF(KWSYS_STANDALONE OR CMake_SOURCE_DIR)

# Enforce component dependencies.
IF(KWSYS_USE_SystemTools)
  SET(KWSYS_USE_Directory 1)
ENDIF(KWSYS_USE_SystemTools)
IF(KWSYS_USE_Glob)
  SET(KWSYS_USE_Directory 1)
  SET(KWSYS_USE_SystemTools 1)
  SET(KWSYS_USE_RegularExpression 1)
ENDIF(KWSYS_USE_Glob)
IF(KWSYS_USE_Process)
  SET(KWSYS_USE_System 1)
ENDIF(KWSYS_USE_Process)
IF(KWSYS_USE_SystemInformation)
  SET(KWSYS_USE_FundamentalType 1)
  SET(KWSYS_USE_Process 1)
ENDIF(KWSYS_USE_SystemInformation)

# Setup the large file support default.
IF(KWSYS_LFS_DISABLE)
  SET(KWSYS_LFS_REQUESTED 0)
ELSE(KWSYS_LFS_DISABLE)
  SET(KWSYS_LFS_REQUESTED 1)
ENDIF(KWSYS_LFS_DISABLE)

# Enable testing if building standalone.
IF(KWSYS_STANDALONE)
  INCLUDE(Dart)
  MARK_AS_ADVANCED(BUILD_TESTING DART_ROOT TCL_TCLSH)
  IF(BUILD_TESTING)
    ENABLE_TESTING()
  ENDIF(BUILD_TESTING)
ENDIF(KWSYS_STANDALONE)

# Include helper macros.
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/kwsysPlatformTests.cmake)
INCLUDE(CheckTypeSize)

# Do full dependency headers.
INCLUDE_REGULAR_EXPRESSION("^.*$")

# Choose which kind of install commands to use.
IF(COMMAND INSTALL)
  # Use new KWSYS_INSTALL_*_DIR variable names to control installation.
  # Take defaults from the old names.  Note that there was no old name
  # for the bin dir, so we take the old lib dir name so DLLs will be
  # installed in a compatible way for old code.
  IF(NOT KWSYS_INSTALL_INCLUDE_DIR)
    STRING(REGEX REPLACE "^/" "" KWSYS_INSTALL_INCLUDE_DIR
      "${KWSYS_HEADER_INSTALL_DIR}")
  ENDIF(NOT KWSYS_INSTALL_INCLUDE_DIR)
  IF(NOT KWSYS_INSTALL_LIB_DIR)
    STRING(REGEX REPLACE "^/" "" KWSYS_INSTALL_LIB_DIR
      "${KWSYS_LIBRARY_INSTALL_DIR}")
  ENDIF(NOT KWSYS_INSTALL_LIB_DIR)
  IF(NOT KWSYS_INSTALL_BIN_DIR)
    STRING(REGEX REPLACE "^/" "" KWSYS_INSTALL_BIN_DIR
      "${KWSYS_LIBRARY_INSTALL_DIR}")
  ENDIF(NOT KWSYS_INSTALL_BIN_DIR)

  # Setup header install rules.
  SET(KWSYS_INSTALL_INCLUDE_OPTIONS)
  IF(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT)
    SET(KWSYS_INSTALL_INCLUDE_OPTIONS ${KWSYS_INSTALL_INCLUDE_OPTIONS}
      COMPONENT ${KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT}
      )
  ENDIF(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT)

  # Setup library install rules.
  SET(KWSYS_INSTALL_LIBRARY_RULE)
  IF(KWSYS_INSTALL_LIB_DIR)
    # Install the shared library to the lib directory.
    SET(KWSYS_INSTALL_LIBRARY_RULE ${KWSYS_INSTALL_LIBRARY_RULE}
      LIBRARY DESTINATION ${KWSYS_INSTALL_LIB_DIR}
      )
    # Assign the shared library to the runtime component.
    IF(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME)
      SET(KWSYS_INSTALL_LIBRARY_RULE ${KWSYS_INSTALL_LIBRARY_RULE}
        COMPONENT ${KWSYS_INSTALL_COMPONENT_NAME_RUNTIME}
        )
    ENDIF(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME)

    # Install the archive to the lib directory.
    SET(KWSYS_INSTALL_LIBRARY_RULE ${KWSYS_INSTALL_LIBRARY_RULE}
      ARCHIVE DESTINATION ${KWSYS_INSTALL_LIB_DIR}
      )
    # Assign the archive to the development component.
    IF(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT)
      SET(KWSYS_INSTALL_LIBRARY_RULE ${KWSYS_INSTALL_LIBRARY_RULE}
        COMPONENT ${KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT}
        )
    ENDIF(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT)
  ENDIF(KWSYS_INSTALL_LIB_DIR)
  IF(KWSYS_INSTALL_BIN_DIR)
    # Install the runtime library to the bin directory.
    SET(KWSYS_INSTALL_LIBRARY_RULE ${KWSYS_INSTALL_LIBRARY_RULE}
      RUNTIME DESTINATION ${KWSYS_INSTALL_BIN_DIR}
      )
    # Assign the runtime library to the runtime component.
    IF(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME)
      SET(KWSYS_INSTALL_LIBRARY_RULE ${KWSYS_INSTALL_LIBRARY_RULE}
        COMPONENT ${KWSYS_INSTALL_COMPONENT_NAME_RUNTIME}
        )
    ENDIF(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME)
  ENDIF(KWSYS_INSTALL_BIN_DIR)

  # Do not support old KWSYS_*_INSTALL_DIR variable names.
  SET(KWSYS_HEADER_INSTALL_DIR)
  SET(KWSYS_LIBRARY_INSTALL_DIR)

ELSE(COMMAND INSTALL)
  # Use old KWSYS_*_INSTALL_DIR variable names.
  # Take defaults from the new names.
  IF(KWSYS_INSTALL_LIB_DIR)
    IF(NOT KWSYS_LIBRARY_INSTALL_DIR)
      SET(KWSYS_LIBRARY_INSTALL_DIR "/${KWSYS_INSTALL_LIB_DIR}")
    ENDIF(NOT KWSYS_LIBRARY_INSTALL_DIR)
  ENDIF(KWSYS_INSTALL_LIB_DIR)
  IF(KWSYS_INSTALL_INCLUDE_DIR)
    IF(NOT KWSYS_HEADER_INSTALL_DIR)
      SET(KWSYS_HEADER_INSTALL_DIR "/${KWSYS_INSTALL_INCLUDE_DIR}")
    ENDIF(NOT KWSYS_HEADER_INSTALL_DIR)
  ENDIF(KWSYS_INSTALL_INCLUDE_DIR)

  # Do not support new KWSYS_INSTALL_*_DIR variable names.
  SET(KWSYS_INSTALL_BIN_DIR)
  SET(KWSYS_INSTALL_INCLUDE_DIR)
  SET(KWSYS_INSTALL_LIB_DIR)
ENDIF(COMMAND INSTALL)

# Work-around for CMake 1.6.7 bug in custom command dependencies when
# there is no executable output path.
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH "${PROJECT_BINARY_DIR}" CACHE PATH
      "Output directory for executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

# Generated source files will need this header.
STRING(COMPARE EQUAL "${PROJECT_SOURCE_DIR}" "${PROJECT_BINARY_DIR}"
  KWSYS_IN_SOURCE_BUILD)
IF(NOT KWSYS_IN_SOURCE_BUILD)
  CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/kwsysPrivate.h
    ${PROJECT_BINARY_DIR}/kwsysPrivate.h COPY_ONLY IMMEDIATE)
ENDIF(NOT KWSYS_IN_SOURCE_BUILD)

#-----------------------------------------------------------------------------
# We require ANSI support from the C compiler.  Add any needed flags.
IF(CMAKE_ANSI_CFLAGS)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_ANSI_CFLAGS}")
ENDIF(CMAKE_ANSI_CFLAGS)

#-----------------------------------------------------------------------------
# Adjust compiler flags for some platforms.
IF(NOT CMAKE_COMPILER_IS_GNUCXX)

## kwstyle 1.0.0+cvs20120330

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(KWStyle)

# Output directories
IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${KWStyle_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${KWStyle_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

SET(KWStyle_MAJOR_VERSION "1")
SET(KWStyle_MINOR_VERSION "0")
SET(KWStyle_PATCH_VERSION "1")

# Disable MSVC 8 warnings
IF(WIN32)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
ENDIF(WIN32)

# Add testing
ENABLE_TESTING()
INCLUDE(CTest)

IF (BUILD_TESTING)
  SUBDIRS(Testing)
ENDIF (BUILD_TESTING)

INCLUDE_DIRECTORIES(
${CMAKE_CURRENT_BINARY_DIR}
${KWStyle_BINARY_DIR}/Utilities
)

SET(KWStyle_HDRS
kwsParser.h
kwsHeader.h
kwsXMLReader.h
kwsGenerator.h
kwsTestFile.h
metaCommand.h
)

SET(KWStyle_SRCS
metaCommand.cxx
kwsParser.cxx
kwsXMLReader.cxx
kwsGenerator.cxx
kwsCheckLineLength.cxx
kwsCheckHeader.cxx
kwsCheckSemicolonSpace.cxx
kwsCheckIfNDefDefine.cxx
kwsCheckTypedefs.cxx
kwsCheckIndent.cxx
kwsCheckEndOfFileNewLine.cxx
kwsCheckDeclarationOrder.cxx
kwsCheckInternalVariables.cxx
kwsCheckNamespace.cxx
kwsCheckComments.cxx
kwsCheckTabs.cxx
kwsCheckNameOfClass.cxx
kwsCheckEmptyLines.cxx
kwsCheckTemplate.cxx
kwsCheckOperator.cxx
kwsCheckBlackList.cxx
kwsCheckExtraSpaces.cxx
kwsCheckStatementPerLine.cxx
kwsCheckVariablePerLine.cxx
kwsCheckBadCharacters.cxx
kwsCheckStruct.cxx
kwsCheckVariables.cxx
kwsCheckMemberFunctions.cxx
kwsCheckFunctions.cxx
)

SUBDIRS(Utilities)

SET(KWStyle_EXECUTABLE_DIRS ${EXECUTABLE_OUTPUT_PATH})
SET(KWStyle_LIBRARY_DIRS ${LIBRARY_OUTPUT_PATH})

# Configure the export configuration
SUBDIRS(CMake/ExportConfiguration)

CONFIGURE_FILE(${KWStyle_SOURCE_DIR}/KWStyleConfigure.h.in 
  ${KWStyle_BINARY_DIR}/KWStyleConfigure.h)

ADD_LIBRARY(KWStyleLib ${KWStyle_SRCS} ${KWStyle_HDRS})
ADD_EXECUTABLE(KWStyle kwsStyle.cxx)
TARGET_LINK_LIBRARIES(KWStyle KWStyleLib kwssys)

# Move the executable to the top binary tree
GET_TARGET_PROPERTY(EXECUTABLE_PATH KWStyle LOCATION)
GET_FILENAME_COMPONENT(EXECUTABLE_NAME ${EXECUTABLE_PATH} NAME)

ADD_CUSTOM_COMMAND(
   TARGET KWStyle
   POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E copy ${EXECUTABLE_PATH} ${KWStyle_BINARY_DIR}/${EXECUTABLE_NAME}
 )

# Installation file
INSTALL(TARGETS KWStyle
        RUNTIME DESTINATION bin)

INSTALL(FILES ${KWStyle_SOURCE_DIR}/Documentation/Install/ITK.kws.xml DESTINATION share/KWStyle)
INSTALL(FILES ${KWStyle_SOURCE_DIR}/Documentation/Install/VTK.kws.xml DESTINATION share/KWStyle)

# Install the headers
INSTALL(FILES ${KWStyle_SOURCE_DIR}/Web/headers/VTKHeader.h DESTINATION share/KWStyle/headers)
INSTALL(FILES ${KWStyle_SOURCE_DIR}/Web/headers/ITKHeader.h DESTINATION share/KWStyle/headers)

# Install the logo
INSTALL(FILES ${KWStyle_SOURCE_DIR}/Documentation/logosmall.jpg DESTINATION share/KWStyle)

# CPack options
INCLUDE(InstallRequiredSystemLibraries)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "KWStyle")
SET(CPACK_PACKAGE_VENDOR "Kitware Inc.")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/ReadMe.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/Copyright.txt")
SET(CPACK_PACKAGE_VERSION_MAJOR "1")
SET(CPACK_PACKAGE_VERSION_MINOR "0")
SET(CPACK_PACKAGE_VERSION_PATCH "0")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "KWStyle ${KWStyle_VERSION_MAJOR}.${KWStyle_VERSION_MINOR}")
IF(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  SET(CPACK_PACKAGE_ICON "${KWStyle_SOURCE_DIR}/Web/images\\\\TitleBar.bmp")
  SET(CPACK_NSIS_INSTALLED_ICON_NAME "relwithdebinfo\\\\KWStyle.exe")
  SET(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} The source code checker")
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\public.kitware.com/KWStyle")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\public.kitware.com/KWStyle")
  SET(CPACK_NSIS_MODIFY_PATH ON)
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_STRIP_FILES "bin/KWStyle")
  SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF(WIN32 AND NOT UNIX)
#SET(CPACK_PACKAGE_EXECUTABLES "KWStyle" "KWStyle")
INCLUDE(CPack)

=== Testing/CMakeLists.txt ===
--- 
+++ 
@@ -60,3 +60,8 @@
 ADD_TEST_FROM_BUG_TRACKER(5032 test.h)
 ADD_TEST_FROM_BUG_TRACKER(5059 test.h)
 ADD_TEST_FROM_BUG_TRACKER(5086 test.h)
+ADD_TEST_FROM_BUG_TRACKER(9934 test.h)
+ADD_TEST_FROM_BUG_TRACKER(9935 test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(9937 test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(9938 test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(9939 test.cxx)

=== Utilities/CMakeLists.txt ===
#-----------------------------------------------------------------------------
# Create the kwsys library for ITK.
SET(KWSYS_NAMESPACE kwssys)
SET(KWSYS_USE_SystemTools 1)
SET(KWSYS_USE_RegularExpression 1)
SET(KWSYS_USE_Directory 1)
SET(KWSYS_USE_Base64 1)
SET(KWSYS_USE_FundamentalType 1)
SET(KWSYS_USE_CommandLineArguments 1)
SET(KWSYS_USE_Process 1)
SET(KWSYS_USE_DynamicLoader 1)
SET(KWSYS_USE_Glob 1)
SET(KWSYS_USE_Registry 1)
SET(KWSYS_HEADER_ROOT ${KWStyle_BINARY_DIR}/Utilities)
SET(KWSYS_PROPERTIES_CXX ${KWStyle_LIBRARY_PROPERTIES})

# Do not install header
SET(KWStyle_INSTALL_NO_DEVELOPMENT 1)

SET(KWSYS_LIBRARY_INSTALL_DIR)
IF(NOT KWStyle_INSTALL_NO_LIBRARIES)
  SET(KWSYS_LIBRARY_INSTALL_DIR ${KWStyle_INSTALL_LIB_DIR})
ENDIF(NOT KWStyle_INSTALL_NO_LIBRARIES)
SET(KWSYS_HEADER_INSTALL_DIR)
IF(NOT KWStyle_INSTALL_NO_DEVELOPMENT)
  SET(KWSYS_HEADER_INSTALL_DIR ${KWStyle_INSTALL_INCLUDE_DIR}/Utilities)
ENDIF(NOT KWStyle_INSTALL_NO_DEVELOPMENT)
SET(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME RuntimeLibraries)
SET(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT Development)
SUBDIRS(KWSys)

=== CMake/ExportConfiguration/CMakeLists.txt ===
# Generate the KWStyleConfig.cmake file in the build tree. Also configure
# one for installation. The file tells external projects how to use
# KWStyle.


#-----------------------------------------------------------------------------
# Settings specific to the build tree.


# The "use" file.
SET(KWStyle_USE_FILE_CONFIG 
  ${CMAKE_CURRENT_SOURCE_DIR}/UseKWStyle.cmake)

# The build settings file.
SET(KWStyle_BUILD_SETTINGS_FILE_CONFIG 
  ${KWStyle_BINARY_DIR}/KWStyleBuildSettings.cmake)

# The library directories.
SET(KWStyle_LIBRARY_DIRS ${KWStyle_LIBRARY_DIRS})

# The EXECUTABLE directories.
SET(KWStyle_EXECUTABLE_DIRS ${KWStyle_EXECUTABLE_DIRS})

# The include directories.
SET(KWStyle_INCLUDE_DIRS_CONFIG ${KWStyle_INCLUDE_PATH})

# The library dependencies file.
SET(KWStyle_LIBRARY_DEPENDS_FILE 
  ${KWStyle_BINARY_DIR}/KWStyleLibraryDepends.cmake)

# The CMake macros dir.
SET(KWStyle_CMAKE_DIR_CONFIG 
  ${KWStyle_CMAKE_DIR})

# The build configuration information.
SET(KWStyle_CONFIGURATION_TYPES_CONFIG ${KWStyle_CONFIGURATION_TYPES})
SET(KWStyle_BUILD_TYPE_CONFIG ${CMAKE_BUILD_TYPE})

# Configure KWStyleConfig.cmake for the build tree.
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/KWStyleConfig.cmake.in
  ${KWStyle_BINARY_DIR}/KWStyleConfig.cmake @ONLY IMMEDIATE)

=== Utilities/KWSys/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,13 @@
 #=============================================================================
-#
-#  Program:   KWSys - Kitware System Library
-#  Module:    $RCSfile: CMakeLists.txt,v $
-#
-#  Copyright (c) Kitware, Inc., Insight Consortium.  All rights reserved.
-#  See Copyright.txt or http://www.kitware.com/Copyright.htm for details.
-#
-#     This software is distributed WITHOUT ANY WARRANTY; without even
-#     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-#     PURPOSE.  See the above copyright notices for more information.
-#
+# KWSys - Kitware System Library
+# Copyright 2000-2009 Kitware, Inc., Insight Software Consortium
+#
+# Distributed under the OSI-approved BSD License (the "License");
+# see accompanying file Copyright.txt for details.
+#
+# This software is distributed WITHOUT ANY WARRANTY; without even the
+# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the License for more information.
 #=============================================================================
 
 # The Kitware System Library is intended to be included in other
@@ -55,6 +53,8 @@
 #  KWSYS_INSTALL_INCLUDE_DIR   kwsys should be installed by a "make install".
 #                              The values should be specified relative to
 #                              the installation prefix and NOT start with '/'.
+#  KWSYS_INSTALL_DOC_DIR     = The installation target directory for documentation
+#                              such as copyright information.
 #
 #  KWSYS_INSTALL_COMPONENT_NAME_RUNTIME     = Name of runtime and development
 #  KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT   installation components.
@@ -102,6 +102,14 @@
 # KWSys will be fixed, but no notification will necessarily be sent to
 # any outside mailing list and no documentation of the change will be
 # written.
+
+CMAKE_MINIMUM_REQUIRED(VERSION 2.4.5 FATAL_ERROR)
+IF(COMMAND CMAKE_POLICY)
+  CMAKE_POLICY(SET CMP0003 NEW)
+ENDIF(COMMAND CMAKE_POLICY)
+
+# Allow empty endif() and such with CMake 2.4.
+SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS 1)
 
 #-----------------------------------------------------------------------------
 # If a namespace is not specified, use "kwsys" and enable testing.
@@ -111,12 +119,6 @@
   SET(KWSYS_NAMESPACE "kwsys")
   SET(KWSYS_STANDALONE 1)
 ENDIF(NOT KWSYS_NAMESPACE)
-IF(KWSYS_STANDALONE)
-  CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
-  IF(COMMAND CMAKE_POLICY)
-    CMAKE_POLICY(SET CMP0003 NEW)
-  ENDIF(COMMAND CMAKE_POLICY)
-ENDIF(KWSYS_STANDALONE)
 
 #-----------------------------------------------------------------------------
 # The project name is that of the specified namespace.
@@ -139,11 +141,16 @@
     "KWSYS_HEADER(%)=<${KWSYS_NAMESPACE}/%>"
     )
 ENDIF(COMMAND SET_PROPERTY)
+# add option to disable memory cleanup at exit of putenv memory
+IF(DEFINED KWSYS_DO_NOT_CLEAN_PUTENV)
+  SET(KWSYS_DO_NOT_CLEAN_PUTENV 1)
+ELSE(DEFINED KWSYS_DO_NOT_CLEAN_PUTENV)
+  SET(KWSYS_DO_NOT_CLEAN_PUTENV 0)
+ENDIF(DEFINED KWSYS_DO_NOT_CLEAN_PUTENV)
 
 # Select library components.
 IF(KWSYS_STANDALONE OR CMake_SOURCE_DIR)
   SET(KWSYS_ENABLE_C 1)
-
   # Enable all components.
   SET(KWSYS_USE_Base64 1)
   SET(KWSYS_USE_Directory 1)
@@ -294,13 +301,6 @@
   SET(KWSYS_INSTALL_LIB_DIR)
 ENDIF(COMMAND INSTALL)
 
-# Work-around for CMake 1.6.7 bug in custom command dependencies when
-# there is no executable output path.
-IF(NOT EXECUTABLE_OUTPUT_PATH)
-  SET(EXECUTABLE_OUTPUT_PATH "${PROJECT_BINARY_DIR}" CACHE PATH
-      "Output directory for executables.")
-ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
-
 # Generated source files will need this header.
 STRING(COMPARE EQUAL "${PROJECT_SOURCE_DIR}" "${PROJECT_BINARY_DIR}"
   KWSYS_IN_SOURCE_BUILD)
@@ -315,6 +315,3 @@
   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_ANSI_CFLAGS}")
 ENDIF(CMAKE_ANSI_CFLAGS)
 
-#-----------------------------------------------------------------------------
-# Adjust compiler flags for some platforms.
-IF(NOT CMAKE_COMPILER_IS_GNUCXX)

=== debian/changelog ===
kwstyle (1.0.0+cvs20120330-3) unstable; urgency=low

  * Fix hardening compilation. Closes: #666529
  * Really fix test failure on arch where char is unsigned
  * add --parallel flag.

 -- Mathieu Malaterre <malat@debian.org>  Wed, 04 Apr 2012 13:42:07 +0200

kwstyle (1.0.0+cvs20120330-2) unstable; urgency=low

  * Fix test failure on arch where char is unsigned.

 -- Mathieu Malaterre <malat@debian.org>  Mon, 02 Apr 2012 21:44:20 +0200

kwstyle (1.0.0+cvs20120330-1) unstable; urgency=low

  * New upstream
  * Use my d.o alias
  * Bump Std-Vers to 3.9.3, no changes needed
  * Switch to dpkg-source 3.0 (quilt) format
  * Use hardening flags
  * Use straight dh, instead of cdbs

 -- Mathieu Malaterre <malat@debian.org>  Fri, 30 Mar 2012 15:55:58 +0200

kwstyle (1.0.0+cvs20090716-3) unstable; urgency=low

  * Fix debian/copyright file

 -- Mathieu Malaterre (malat) <mathieu.malaterre@gmail.com>  Wed, 02 Sep 2009 14:56:02 +0200

kwstyle (1.0.0+cvs20090716-2) unstable; urgency=low

  * Fix KWStyle documentation
  * Some lintian fix from unstable 

 -- Mathieu Malaterre (malat) <mathieu.malaterre@gmail.com>  Wed, 05 Aug 2009 10:02:51 +0200

kwstyle (1.0.0+cvs20090716-1) unstable; urgency=low

  * Initial release (Closes: #537227)

 -- Mathieu Malaterre (malat) <mathieu.malaterre@gmail.com>  Thu, 16 Jul 2009 11:40:13 +0200

=== debian/control ===
Source: kwstyle
Section: devel
Priority: optional
Maintainer: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 8), cmake
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/git/collab-maint/kwstyle.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/kwstyle.git
Homepage: http://public.kitware.com/KWStyle/

Package: kwstyle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Style checker for source code
 KWStyle is integrated in the software process to ensure that the code written
 by several users is consistent and can be viewed/printed as it was written by
 one person.
 .
 KWStyle is primarily checking C/C++ source code but can be easily extended to
 other languages. It assumes that the code is syntaxically correct, i.e it 
 compiles on a standard compiler.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
# http://bugs.debian.org/653916
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --parallel

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
                -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

pkg_run = kwstyle

override_dh_install:
	dh_installman -p$(pkg_run) debian/KWStyle.1
	dh_installdocs -p$(pkg_run) Web

get-orig-source:
	./debian/get-orig-source

.PHONY: get-orig-source

## kwstyle 1.0.1%2Bgit3224cf2

=== debian/changelog ===
kwstyle (1.0.1+git3224cf2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:17:39 +0100

kwstyle (1.0.1+git3224cf2-1) unstable; urgency=medium

  * New upstream release. Now hosted at https://github.com/Kitware/KWStyle.
  * Fix "FTBFS with GCC 6: no match for" by new upstream release
    (Closes: #811822)
  * New maintainer (Closes: #786984).
  * Remove get-orig-source. Pristine tar can be generated from pristine-tar
    branch.
  * Increase debhelper compatibility to v9.
  * debian/control: Change upstream URL.
  * debian/control: Fix typos in description.
  * debian/copyright: Update after upstream code review and format.
  * debian/copyright: Change source URL.
  * debian/copyright: Add myself to copyright for Debian packaging.
  * debian/rules: Remove workaround for old CMake bug.
  * debian/rules: Do not override default debhelper CMake arguments.
  * debian/rules: Remove useless lines.
  * debian/rules: Enable hardening build flags.
  * Update man page KWStyle(1).

 -- Benjamin Eikel <debian@eikel.org>  Sun, 06 Mar 2016 12:57:08 +0100

## kwstyle 1.0.1+git3224cf2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,14 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
-IF(COMMAND CMAKE_POLICY)
-  CMAKE_POLICY(SET CMP0003 NEW)
-ENDIF(COMMAND CMAKE_POLICY)
+CMAKE_MINIMUM_REQUIRED(VERSION 2.8.4)
+
+FOREACH(p
+    CMP0003
+    CMP0026
+    CMP0054
+    )
+  IF(POLICY ${p})
+    CMAKE_POLICY(SET ${p} NEW)
+  ENDIF()
+ENDFOREACH()
 
 PROJECT(KWStyle)
 
@@ -36,6 +43,7 @@
 INCLUDE_DIRECTORIES(
 ${CMAKE_CURRENT_BINARY_DIR}
 ${KWStyle_BINARY_DIR}/Utilities
+${KWStyle_SOURCE_DIR}/Utilities
 )
 
 SET(KWStyle_HDRS
@@ -77,6 +85,8 @@
 kwsCheckVariables.cxx
 kwsCheckMemberFunctions.cxx
 kwsCheckFunctions.cxx
+kwsCheckUsingDirectives.cxx
+kwsCheckRelativePathInInclude.cxx
 )
 
 SUBDIRS(Utilities)
@@ -94,15 +104,9 @@
 ADD_EXECUTABLE(KWStyle kwsStyle.cxx)
 TARGET_LINK_LIBRARIES(KWStyle KWStyleLib kwssys)
 
-# Move the executable to the top binary tree
-GET_TARGET_PROPERTY(EXECUTABLE_PATH KWStyle LOCATION)
-GET_FILENAME_COMPONENT(EXECUTABLE_NAME ${EXECUTABLE_PATH} NAME)
-
-ADD_CUSTOM_COMMAND(
-   TARGET KWStyle
-   POST_BUILD
-   COMMAND ${CMAKE_COMMAND} -E copy ${EXECUTABLE_PATH} ${KWStyle_BINARY_DIR}/${EXECUTABLE_NAME}
- )
+ADD_CUSTOM_COMMAND(TARGET KWStyle POST_BUILD COMMAND "${CMAKE_COMMAND}" -E copy 
+     "$<TARGET_FILE:KWStyle>" "${KWStyle_BINARY_DIR}/${EXECUTABLE_NAME}"
+  COMMENT "Move the executable to the top binary tree")
 
 # Installation file
 INSTALL(TARGETS KWStyle
@@ -123,7 +127,7 @@
 
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "KWStyle")
 SET(CPACK_PACKAGE_VENDOR "Kitware Inc.")
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/ReadMe.txt")
+SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/Copyright.txt")
 SET(CPACK_PACKAGE_VERSION_MAJOR "1")
 SET(CPACK_PACKAGE_VERSION_MINOR "0")

=== Testing/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,7 @@
 
 ENDMACRO(ADD_TEST_FROM_BUG_TRACKER BUG_NUMBER FILENAME)
 
+ADD_TEST_FROM_BUG_TRACKER(kwsTabsTest test.cxx)
 ADD_TEST_FROM_BUG_TRACKER(0001 test.cpp)
 ADD_TEST_FROM_BUG_TRACKER(4204 test.cpp)
 ADD_TEST_FROM_BUG_TRACKER(4227 test.cpp)
@@ -65,3 +66,4 @@
 ADD_TEST_FROM_BUG_TRACKER(9937 test.cxx)
 ADD_TEST_FROM_BUG_TRACKER(9938 test.cxx)
 ADD_TEST_FROM_BUG_TRACKER(9939 test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(10872 test.cxx)

=== debian/control ===
Source: kwstyle
Maintainer: Benjamin Eikel <debian@eikel.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/kwstyle.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/kwstyle.git
Homepage: https://kitware.github.io/KWStyle/

Package: kwstyle
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Style checker for source code
 KWStyle is integrated in the software process to ensure that the code written
 by several users is consistent and can be viewed/printed as it was written by
 one person.
 .
 KWStyle is primarily checking C/C++ source code but can be easily extended to
 other languages. It assumes that the code is syntactically correct, i.e., it 
 compiles on a standard compiler.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

pkg_run = kwstyle

override_dh_install:
	dh_installman -p$(pkg_run) debian/KWStyle.1
	dh_installdocs -p$(pkg_run) Web

## kwstyle 1.1.0~git20200506.b253a2b

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

foreach(p
    # Place newer policies here if needed for cmake greater than 3.10.2
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

# ==== Define language standard configurations requiring at least c++11 standard
if(CMAKE_CXX_STANDARD EQUAL "98" )
   message(FATAL_ERROR "CMAKE_CXX_STANDARD:STRING=98 is not supported in ITK version 5 and greater.")
endif()

#####
##  Set the default target properties for ITK
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11) # Supported values are ``11``, ``14``, and ``17``.
endif()
if(NOT CMAKE_CXX_STANDARD_REQUIRED)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
if(NOT CMAKE_CXX_EXTENSIONS)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

project(KWStyle
   VERSION 1.1.0
   DESCRIPTION "Kitware Style Checker"
   LANGUAGES C CXX
)


#-----------------------------------------------------------------------------
if(NOT COMMAND SETIFEMPTY)
  macro(SETIFEMPTY)
    set(KEY ${ARGV0})
    set(VALUE ${ARGV1})
    if(NOT ${KEY})
      set(${ARGV})
    endif()
  endmacro()
endif()

#-----------------------------------------------------------------------------
SETIFEMPTY(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${KWStyle_BINARY_DIR}/bin)
SETIFEMPTY(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${KWStyle_BINARY_DIR}/bin)
SETIFEMPTY(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${KWStyle_BINARY_DIR}/bin)
SETIFEMPTY(CMAKE_BUNDLE_OUTPUT_DIRECTORY  ${KWStyle_BINARY_DIR}/bin)
file(MAKE_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

set(CXX_TEST_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

# Disable MSVC 8 warnings
if(WIN32)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
endif()

# Add testing
enable_testing()
include(CTest)

include_directories(
${CMAKE_CURRENT_BINARY_DIR}
${KWStyle_BINARY_DIR}/Utilities
${KWStyle_SOURCE_DIR}/Utilities
)

set(KWStyle_EXECUTABLE_DIRS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
set(KWStyle_LIBRARY_DIRS ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

# Configure the export configuration
add_subdirectory(CMake/ExportConfiguration)

configure_file(${KWStyle_SOURCE_DIR}/KWStyleConfigure.h.in
  ${KWStyle_BINARY_DIR}/KWStyleConfigure.h)

set(KWStyle_HDRS
kwsParser.h
kwsHeader.h
kwsXMLReader.h
kwsGenerator.h
kwsTestFile.h
metaCommand.h
)

set(KWStyle_SRCS
metaCommand.cxx
kwsParser.cxx
kwsXMLReader.cxx
kwsGenerator.cxx
kwsCheckLineLength.cxx
kwsCheckHeader.cxx
kwsCheckSemicolonSpace.cxx
kwsCheckIfNDefDefine.cxx
kwsCheckTypedefs.cxx
kwsCheckIndent.cxx
kwsCheckEndOfFileNewLine.cxx
kwsCheckDeclarationOrder.cxx
kwsCheckInternalVariables.cxx
kwsCheckNamespace.cxx
kwsCheckComments.cxx
kwsCheckTabs.cxx
kwsCheckNameOfClass.cxx
kwsCheckEmptyLines.cxx
kwsCheckTemplate.cxx
kwsCheckOperator.cxx
kwsCheckBlackList.cxx
kwsCheckExtraSpaces.cxx
kwsCheckStatementPerLine.cxx
kwsCheckVariablePerLine.cxx
kwsCheckBadCharacters.cxx
kwsCheckStruct.cxx
kwsCheckVariables.cxx
kwsCheckMemberFunctions.cxx
kwsCheckFunctions.cxx
kwsCheckUsingDirectives.cxx
kwsCheckRelativePathInInclude.cxx
kwsCheckIfWhileForUntil.cxx
kwsCheckComma.cxx
kwsCheckParenthesis.cxx
)

add_subdirectory(Utilities)

add_library(KWStyleLib ${KWStyle_SRCS} ${KWStyle_HDRS})
add_executable(KWStyle kwsStyle.cxx)
target_link_libraries(KWStyle KWStyleLib kwssys)

# Move the executable to the top binary tree
add_custom_command(
   TARGET KWStyle
   POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:KWStyle>
     ${KWStyle_BINARY_DIR}/$<TARGET_FILE_NAME:KWStyle>
 )

if(BUILD_TESTING)
  add_subdirectory(Testing)
endif()

# Installation file
install(TARGETS KWStyle
        RUNTIME DESTINATION bin)

install(FILES ${KWStyle_SOURCE_DIR}/Documentation/Install/ITK.kws.xml DESTINATION share/KWStyle)
install(FILES ${KWStyle_SOURCE_DIR}/Documentation/Install/VTK.kws.xml DESTINATION share/KWStyle)

# Install the headers
install(FILES ${KWStyle_SOURCE_DIR}/Web/headers/VTKHeader.h DESTINATION share/KWStyle/headers)
install(FILES ${KWStyle_SOURCE_DIR}/Web/headers/ITKHeader.h DESTINATION share/KWStyle/headers)

# Install the logo
install(FILES ${KWStyle_SOURCE_DIR}/Documentation/logosmall.jpg DESTINATION share/KWStyle)

# CPack options
include(InstallRequiredSystemLibraries)

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "KWStyle")
set(CPACK_PACKAGE_VENDOR "Kitware Inc.")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/Copyright.txt")

set(CPACK_PACKAGE_VERSION_MAJOR "${${PROJECT_NAME}_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${${PROJECT_NAME}_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${${PROJECT_NAME}_VERSION_PATCH}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "KWStyle ${KWStyle_VERSION_MAJOR}.${KWStyle_VERSION_MINOR}")
if(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  set(CPACK_PACKAGE_ICON "${KWStyle_SOURCE_DIR}/Web/images\\\\TitleBar.bmp")
  set(CPACK_NSIS_INSTALLED_ICON_NAME "relwithdebinfo\\\\KWStyle.exe")
  set(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} The source code checker")
  set(CPACK_NSIS_HELP_LINK "http:\\\\\\\\public.kitware.com/KWStyle")
  set(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\public.kitware.com/KWStyle")
  set(CPACK_NSIS_MODIFY_PATH ON)
else()
  set(CPACK_STRIP_FILES "bin/KWStyle")
  set(CPACK_SOURCE_STRIP_FILES "")
endif()
#set(CPACK_PACKAGE_EXECUTABLES "KWStyle" "KWStyle")
include(CPack)

=== Testing/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,10 @@
-INCLUDE_DIRECTORIES(${KWStyle_SOURCE_DIR})
+include_directories(${KWStyle_SOURCE_DIR})
 
-SET(KWSTYLE_TESTS  ${CXX_TEST_PATH}/KWStyleTests)
+set(KWSTYLE_TESTS  ${CXX_TEST_PATH}/KWStyleTests)
 
-SET(
+set(
  KWStyleTests_SRCS
+ kwsIndentTest.cxx
  kwsSemiColonSpaceTest.cxx
  kwsStatementPerLineTest.cxx
  kwsVariablePerLineTest.cxx
@@ -11,29 +12,29 @@
  kwsBadCharactersTest.cxx
 )
 
-FOREACH(TestFiles ${KWStyleTests_SRCS})   
-  GET_FILENAME_COMPONENT(TestProgram ${TestFiles} NAME_WE)   
-  ADD_TEST(${TestProgram} ${KWSTYLE_TESTS} ${TestProgram}) 
-ENDFOREACH(TestFiles)
+foreach(TestFiles ${KWStyleTests_SRCS})
+  get_filename_component(TestProgram ${TestFiles} NAME_WE)
+  add_test(${TestProgram} ${KWSTYLE_TESTS} ${TestProgram})
+endforeach()
 
-SET(KWStyleTests_SRCS
+set(KWStyleTests_SRCS
  ${KWStyleTests_SRCS}
  kwsRunKWStyleTest.cxx
- )
+)
 
-ADD_EXECUTABLE( KWStyleTests KWStyleTests.cxx ${KWStyleTests_SRCS})
-TARGET_LINK_LIBRARIES(KWStyleTests KWStyleLib kwssys)
+add_executable( KWStyleTests KWStyleTests.cxx ${KWStyleTests_SRCS})
+target_link_libraries(KWStyleTests KWStyleLib kwssys)
 
 
-MACRO(ADD_TEST_FROM_BUG_TRACKER BUG_NUMBER FILENAME)
-  ADD_TEST(Test${BUG_NUMBER} ${KWSTYLE_TESTS}
+macro(ADD_TEST_FROM_BUG_TRACKER BUG_NUMBER FILENAME)
+  add_test(Test${BUG_NUMBER} ${KWSTYLE_TESTS}
   --compare ${KWStyle_SOURCE_DIR}/Testing/Data/${BUG_NUMBER}-output.xml
             ${KWStyle_BINARY_DIR}/${BUG_NUMBER}-output.xml
   kwsRunKWStyleTest ${KWStyle_BINARY_DIR}/KWStyle -xml ${KWStyle_SOURCE_DIR}/Testing/Data/${BUG_NUMBER}-KWStyleConfiguration.kws.xml
   -exportxml ${KWStyle_BINARY_DIR}/${BUG_NUMBER}-output.xml
   ${KWStyle_SOURCE_DIR}/Testing/Data/${BUG_NUMBER}-${FILENAME})
 
-ENDMACRO(ADD_TEST_FROM_BUG_TRACKER BUG_NUMBER FILENAME)
+endmacro()
 
 ADD_TEST_FROM_BUG_TRACKER(kwsTabsTest test.cxx)
 ADD_TEST_FROM_BUG_TRACKER(0001 test.cpp)
@@ -67,3 +68,6 @@
 ADD_TEST_FROM_BUG_TRACKER(9938 test.cxx)
 ADD_TEST_FROM_BUG_TRACKER(9939 test.cxx)
 ADD_TEST_FROM_BUG_TRACKER(10872 test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(kwsIfWhileForUntilTest test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(kwsCommaTest test.cxx)
+ADD_TEST_FROM_BUG_TRACKER(kwsParenthesisTest test.cxx)

=== Utilities/CMakeLists.txt ===
#-----------------------------------------------------------------------------
# Create the kwsys library for ITK.
set(KWSYS_NAMESPACE kwssys)
set(KWSYS_USE_SystemTools 1)
set(KWSYS_USE_RegularExpression 1)
set(KWSYS_USE_Directory 1)
set(KWSYS_USE_Base64 1)
set(KWSYS_USE_FundamentalType 1)
set(KWSYS_USE_CommandLineArguments 1)
set(KWSYS_USE_Process 1)
set(KWSYS_USE_DynamicLoader 1)
set(KWSYS_USE_Glob 1)
set(KWSYS_USE_Registry 1)
set(KWSYS_HEADER_ROOT ${KWStyle_BINARY_DIR}/Utilities)
set(KWSYS_PROPERTIES_CXX ${KWStyle_LIBRARY_PROPERTIES})

# Do not install header
set(KWStyle_INSTALL_NO_DEVELOPMENT 1)

set(KWSYS_LIBRARY_INSTALL_DIR)
if(NOT KWStyle_INSTALL_NO_LIBRARIES)
  set(KWSYS_LIBRARY_INSTALL_DIR ${KWStyle_INSTALL_LIB_DIR})
endif()
set(KWSYS_HEADER_INSTALL_DIR)
if(NOT KWStyle_INSTALL_NO_DEVELOPMENT)
  set(KWSYS_HEADER_INSTALL_DIR ${KWStyle_INSTALL_INCLUDE_DIR}/Utilities)
endif()
set(KWSYS_INSTALL_COMPONENT_NAME_RUNTIME RuntimeLibraries)
set(KWSYS_INSTALL_COMPONENT_NAME_DEVELOPMENT Development)
add_subdirectory(KWSys)

=== CMake/ExportConfiguration/CMakeLists.txt ===
# Generate the KWStyleConfig.cmake file in the build tree. Also configure
# one for installation. The file tells external projects how to use
# KWStyle.


#-----------------------------------------------------------------------------
# Settings specific to the build tree.


# The "use" file.
set(KWStyle_USE_FILE_CONFIG 
  ${CMAKE_CURRENT_SOURCE_DIR}/UseKWStyle.cmake)

# The build settings file.
set(KWStyle_BUILD_SETTINGS_FILE_CONFIG 
  ${KWStyle_BINARY_DIR}/KWStyleBuildSettings.cmake)

# The library directories.
set(KWStyle_LIBRARY_DIRS ${KWStyle_LIBRARY_DIRS})

# The EXECUTABLE directories.
set(KWStyle_EXECUTABLE_DIRS ${KWStyle_EXECUTABLE_DIRS})

# The include directories.
set(KWStyle_INCLUDE_DIRS_CONFIG ${KWStyle_INCLUDE_PATH})

# The library dependencies file.
set(KWStyle_LIBRARY_DEPENDS_FILE 
  ${KWStyle_BINARY_DIR}/KWStyleLibraryDepends.cmake)

# The CMake macros dir.
set(KWStyle_CMAKE_DIR_CONFIG 
  ${KWStyle_CMAKE_DIR})

# The build configuration information.
set(KWStyle_CONFIGURATION_TYPES_CONFIG ${KWStyle_CONFIGURATION_TYPES})
set(KWStyle_BUILD_TYPE_CONFIG ${CMAKE_BUILD_TYPE})

# Configure KWStyleConfig.cmake for the build tree.
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/KWStyleConfig.cmake.in
  ${KWStyle_BINARY_DIR}/KWStyleConfig.cmake @ONLY IMMEDIATE)

=== debian/changelog ===
kwstyle (1.1.0~git20200506.b253a2b-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113091)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 21:38:09 +0300

kwstyle (1.1.0~git20200506.b253a2b-1) unstable; urgency=medium

  * New upstream version 1.1.0~git20200506.b253a2b from
    https://github.com/Kitware/KWStyle.
  * Fix "new version avaiable" by new upstream release
    (Closes: #926378)
  * Standards-Version: 4.5.0 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add basic autopkgtest.
  * Add build dependency on libboost-dev and remove upstream's boost. 
  * Add a watch file.

 -- Benjamin Eikel <debian@eikel.org>  Thu, 21 May 2020 14:12:38 +0200

=== debian/control ===
Source: kwstyle
Maintainer: Benjamin Eikel <debian@eikel.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/eikel/kwstyle
Vcs-Git: https://salsa.debian.org/eikel/kwstyle.git
Homepage: https://kitware.github.io/KWStyle/
Rules-Requires-Root: no

Package: kwstyle
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Style checker for source code
 KWStyle is integrated in the software process to ensure that the code written
 by several users is consistent and can be viewed/printed as it was written by
 one person.
 .
 KWStyle is primarily checking C/C++ source code but can be easily extended to
 other languages. It assumes that the code is syntactically correct, i.e., it
 compiles on a standard compiler.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

pkg_run = kwstyle

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=1.1.0~git%cd.%h" \
https://github.com/Kitware/KWStyle.git \
HEAD debian
